<?php

$z5 = new Z5EncryptAPIV01();
$z5->token = '你的Token';
$z5->secret = '你的Secret';
$file = $z5->encryptFile(
    '<?php function a () { echo "Hello World"; } a();', 
    'helloworld.php');

// $file存储已经加密过的PHP文件


class Z5EncryptException extends Exception {}
class Z5EncryptAPIV01 {

    public $token = '';
    public $secret = '';

    private function getToken ($payload)
    {
        $header = $this->base64(json_encode(array(
            'alg' => 'HS256',
            'typ' => 'JWT'
        ), JSON_UNESCAPED_UNICODE));
        $payload = $this->base64(json_encode($payload, JSON_UNESCAPED_UNICODE));
        $token = $header;
        $token .= '.' . $payload;
        $token .= '.' . $this->signature($token, $this->secret, 'HS256');
        return $token;
    }

    private function base64($input)
    {
        return str_replace('=', '', strtr(base64_encode($input), '+/', '-_'));
    }

    private function signature($input, $key)
    {
        return $this->base64(hash_hmac('sha256', $input, $key, true));
    }

    public function encryptFile ($file, $fileName, $configuration = []) {
        $url = "https://open.api.z5encrypt.com/release/public/v0.1/encrypt";
        $data = array(
            'file' => base64_encode($file),
            'fileName' => $fileName,
            'configuration' => $configuration
        );
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'token: ' . $this->token
        ));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $this->getToken($data));
        $output = curl_exec($ch);
        curl_close($ch);
        $ret = json_decode($output);
        if ($ret->err === 0) {
            return base64_decode($ret->data);
        } else {
            throw new Z5EncryptException($ret->message);
        }
    }
}
